Index: src/ThermoStatContainer.hpp
===================================================================
--- src/ThermoStatContainer.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/ThermoStatContainer.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -16,5 +16,5 @@
 class ConfigFileBuffer;
 
-#define MaxThermostats 6      //!< maximum number of thermostat entries in Ions#ThermostatNames and Ions#ThermostatImplemented
+enum { MaxThermostats=6 };      //!< maximum number of thermostat entries in Ions#ThermostatNames and Ions#ThermostatImplemented
 enum thermostats { None, Woodcock, Gaussian, Langevin, Berendsen, NoseHoover };   //!< Thermostat names for output
 
Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -23,13 +28,15 @@
 #include "CommandLineParser.hpp"
 #include "defs.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "periodentafel.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
+#include "Box.hpp"
 
 #include "atom.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 using namespace std;
@@ -49,42 +56,66 @@
 }
 
-void CommandLineDialog::queryInt(const char* title, int* target, string _description){
-  registerQuery(new IntCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryBoolean(const char* title, bool* target, string _description){
-  registerQuery(new BooleanCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryDouble(const char* title, double* target, string _description){
-  registerQuery(new DoubleCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryString(const char* title, string* target, string _description){
-  registerQuery(new StringCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryStrings(const char* title, vector<string> * target, string _description){
-  registerQuery(new StringsCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryAtom(const char* title, atom **target, string _description) {
-  registerQuery(new AtomCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryMolecule(const char* title, molecule **target, string _description) {
-  registerQuery(new MoleculeCommandLineQuery(title,target, _description));
-}
-
-void CommandLineDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string _description) {
-  registerQuery(new VectorCommandLineQuery(title,target,cellSize,check, _description));
-}
-
-void CommandLineDialog::queryBox(const char* title, double ** const cellSize, string _description) {
-  registerQuery(new BoxCommandLineQuery(title,cellSize,_description));
-}
-
-void CommandLineDialog::queryElement(const char* title, std::vector<element *> *target, string _description){
-  registerQuery(new ElementCommandLineQuery(title,target, _description));
+void CommandLineDialog::queryInt(const char* title, string _description){
+  registerQuery(new IntCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryInts(const char* title, string _description){
+  registerQuery(new IntsCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryBoolean(const char* title, string _description){
+  registerQuery(new BooleanCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryDouble(const char* title, string _description){
+  registerQuery(new DoubleCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryDoubles(const char* title, string _description){
+  registerQuery(new DoublesCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryString(const char* title, string _description){
+  registerQuery(new StringCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryStrings(const char* title, string _description){
+  registerQuery(new StringsCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryAtom(const char* title, string _description) {
+  registerQuery(new AtomCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryAtoms(const char* title, string _description) {
+  registerQuery(new AtomsCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryMolecule(const char* title, string _description) {
+  registerQuery(new MoleculeCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryMolecules(const char* title, string _description) {
+  registerQuery(new MoleculesCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryVector(const char* title, bool check, string _description) {
+  registerQuery(new VectorCommandLineQuery(title,check, _description));
+}
+
+void CommandLineDialog::queryVectors(const char* title, bool check, string _description) {
+  registerQuery(new VectorsCommandLineQuery(title,check, _description));
+}
+
+void CommandLineDialog::queryBox(const char* title, string _description) {
+  registerQuery(new BoxCommandLineQuery(title,_description));
+}
+
+void CommandLineDialog::queryElement(const char* title, string _description){
+  registerQuery(new ElementCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryElements(const char* title, string _description){
+  registerQuery(new ElementsCommandLineQuery(title, _description));
 }
 
@@ -102,6 +133,6 @@
 }
 
-CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(string title,int *_target, string _description) :
-    Dialog::IntQuery(title,_target, _description)
+CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(string title, string _description) :
+    Dialog::IntQuery(title, _description)
 {}
 
@@ -118,6 +149,22 @@
 }
 
-CommandLineDialog::BooleanCommandLineQuery::BooleanCommandLineQuery(string title,bool *_target, string _description) :
-    Dialog::BooleanQuery(title,_target, _description)
+CommandLineDialog::IntsCommandLineQuery::IntsCommandLineQuery(string title, string _description) :
+    Dialog::IntsQuery(title, _description)
+{}
+
+CommandLineDialog::IntsCommandLineQuery::~IntsCommandLineQuery() {}
+
+bool CommandLineDialog::IntsCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing integers for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::BooleanCommandLineQuery::BooleanCommandLineQuery(string title, string _description) :
+    Dialog::BooleanQuery(title, _description)
 {}
 
@@ -134,6 +181,6 @@
 }
 
-CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(string title,string *_target, string _description) :
-    Dialog::StringQuery(title,_target, _description)
+CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(string title, string _description) :
+    Dialog::StringQuery(title, _description)
 {}
 
@@ -150,6 +197,6 @@
 }
 
-CommandLineDialog::StringsCommandLineQuery::StringsCommandLineQuery(string title,vector<string> *_target, string _description) :
-    Dialog::StringsQuery(title,_target, _description)
+CommandLineDialog::StringsCommandLineQuery::StringsCommandLineQuery(string title, string _description) :
+    Dialog::StringsQuery(title, _description)
 {}
 
@@ -161,11 +208,11 @@
     return true;
   } else {
-    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing string for " << getTitle() << "." << endl);
-    return false;
-  }
-}
-
-CommandLineDialog::DoubleCommandLineQuery::DoubleCommandLineQuery(string title,double *_target, string _description) :
-    Dialog::DoubleQuery(title,_target, _description)
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing strings for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::DoubleCommandLineQuery::DoubleCommandLineQuery(string title, string _description) :
+    Dialog::DoubleQuery(title, _description)
 {}
 
@@ -182,6 +229,22 @@
 }
 
-CommandLineDialog::AtomCommandLineQuery::AtomCommandLineQuery(string title, atom **_target, string _description) :
-    Dialog::AtomQuery(title,_target, _description)
+CommandLineDialog::DoublesCommandLineQuery::DoublesCommandLineQuery(string title, string _description) :
+    Dialog::DoublesQuery(title, _description)
+{}
+
+CommandLineDialog::DoublesCommandLineQuery::~DoublesCommandLineQuery() {}
+
+bool CommandLineDialog::DoublesCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<double> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing doubles for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::AtomCommandLineQuery::AtomCommandLineQuery(string title, string _description) :
+    Dialog::AtomQuery(title, _description)
 {}
 
@@ -200,6 +263,28 @@
 }
 
-CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(string title, molecule **_target, string _description) :
-    Dialog::MoleculeQuery(title,_target, _description)
+CommandLineDialog::AtomsCommandLineQuery::AtomsCommandLineQuery(string title, string _description) :
+    Dialog::AtomsQuery(title, _description)
+{}
+
+CommandLineDialog::AtomsCommandLineQuery::~AtomsCommandLineQuery() {}
+
+bool CommandLineDialog::AtomsCommandLineQuery::handle() {
+  std::vector<int> IdxOfAtom;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfAtom = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    for (std::vector<int>::iterator iter = IdxOfAtom.begin(); iter != IdxOfAtom.end(); ++iter) {
+      temp = World::getInstance().getAtom(AtomById(*iter));
+      if (temp)
+        tmp.push_back(temp);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing atoms for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(string title, string _description) :
+    Dialog::MoleculeQuery(title, _description)
 {}
 
@@ -210,9 +295,5 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
-    cout << "IdxOfMol " << IdxOfMol << endl;
-    if (IdxOfMol >= 0)
-      tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
-    else
-      tmp = NULL;
+    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
     return true;
   } else {
@@ -222,6 +303,28 @@
 }
 
-CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(string title, Vector *_target, const double *const _cellSize, bool _check, string _description) :
-    Dialog::VectorQuery(title,_target,_cellSize,_check, _description)
+CommandLineDialog::MoleculesCommandLineQuery::MoleculesCommandLineQuery(string title, string _description) :
+    Dialog::MoleculesQuery(title, _description)
+{}
+
+CommandLineDialog::MoleculesCommandLineQuery::~MoleculesCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculesCommandLineQuery::handle() {
+  std::vector<int> IdxOfMol;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    for (std::vector<int>::iterator iter = IdxOfMol.begin(); iter != IdxOfMol.end(); ++iter) {
+      temp = World::getInstance().getMolecule(MoleculeById(*iter));
+      if (temp)
+        tmp.push_back(temp);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing molecules for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(string title, bool _check, string _description) :
+    Dialog::VectorQuery(title,_check, _description)
 {}
 
@@ -233,7 +336,11 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     temp = CommandLineParser::getInstance().vm[getTitle()].as< VectorValue >();
-    tmp->at(0) = temp.x;
-    tmp->at(1) = temp.y;
-    tmp->at(2) = temp.z;
+    tmp[0] = temp.x;
+    tmp[1] = temp.y;
+    tmp[2] = temp.z;
+    if ((check) && (!World::getInstance().getDomain().isInside(tmp))) {
+      DoeLog(1) && (eLog() << Verbose(1) << "Vector " << tmp << " would be outside of box domain." << endl);
+      return false;
+    }
     return true;
   } else {
@@ -243,7 +350,33 @@
 }
 
-
-CommandLineDialog::BoxCommandLineQuery::BoxCommandLineQuery(string title, double ** const _cellSize, string _description) :
-    Dialog::BoxQuery(title,_cellSize, _description)
+CommandLineDialog::VectorsCommandLineQuery::VectorsCommandLineQuery(string title, bool _check, string _description) :
+    Dialog::VectorsQuery(title,_check, _description)
+{}
+
+CommandLineDialog::VectorsCommandLineQuery::~VectorsCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorsCommandLineQuery::handle() {
+  std::vector<VectorValue> temporary;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temporary = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<VectorValue> >();
+    for(std::vector<VectorValue>::iterator iter = temporary.begin(); iter != temporary.end(); ++iter) {
+      temp[0] = (*iter).x;
+      temp[1] = (*iter).y;
+      temp[2] = (*iter).z;
+      if ((!check) || (World::getInstance().getDomain().isInside(temp)))
+        tmp.push_back(temp);
+      else
+        DoeLog(1) && (eLog() << Verbose(1) << "Vector " << temp << " would be outside of box domain." << endl);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing vectors for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::BoxCommandLineQuery::BoxCommandLineQuery(string title, string _description) :
+    Dialog::BoxQuery(title, _description)
 {}
 
@@ -255,10 +388,15 @@
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     temp = CommandLineParser::getInstance().vm[getTitle()].as< BoxValue >();
-    tmp[0] = temp.xx;
-    tmp[1] = temp.xy;
-    tmp[2] = temp.xz;
-    tmp[3] = temp.yy;
-    tmp[4] = temp.yz;
-    tmp[5] = temp.zz;
+    Matrix M;
+    M.set(0,0, temp.xx);
+    M.set(0,1, temp.yx);
+    M.set(0,2, temp.zx);
+    M.set(1,0, temp.yx);
+    M.set(1,1, temp.yy);
+    M.set(1,2, temp.zy);
+    M.set(2,0, temp.zx);
+    M.set(2,1, temp.zy);
+    M.set(2,2, temp.zz);
+    tmp.setM(M);
     return true;
   } else {
@@ -268,6 +406,6 @@
 }
 
-CommandLineDialog::ElementCommandLineQuery::ElementCommandLineQuery(string title, std::vector<element *> *target, string _description) :
-    Dialog::ElementQuery(title,target, _description)
+CommandLineDialog::ElementCommandLineQuery::ElementCommandLineQuery(string title, string _description) :
+    Dialog::ElementQuery(title, _description)
 {}
 
@@ -278,16 +416,36 @@
   // TODO: vector of ints and removing first is not correctly implemented yet. How to remove from a vector?
   periodentafel *periode = World::getInstance().getPeriode();
-  element *elemental = NULL;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    int Z = CommandLineParser::getInstance().vm[getTitle()].as< int >();
+    tmp = periode->FindElement(Z);
+    ASSERT(tmp != NULL, "Invalid element specified in ElementCommandLineQuery");
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing element for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
+CommandLineDialog::ElementsCommandLineQuery::ElementsCommandLineQuery(string title, string _description) :
+    Dialog::ElementsQuery(title, _description)
+{}
+
+CommandLineDialog::ElementsCommandLineQuery::~ElementsCommandLineQuery()
+{}
+
+bool CommandLineDialog::ElementsCommandLineQuery::handle() {
+  // TODO: vector of ints and removing first is not correctly implemented yet. How to remove from a vector?
+  periodentafel *periode = World::getInstance().getPeriode();
   if (CommandLineParser::getInstance().vm.count(getTitle())) {
     vector<int> AllElements = CommandLineParser::getInstance().vm[getTitle()].as< vector<int> >();
     for (vector<int>::iterator ZRunner = AllElements.begin(); ZRunner != AllElements.end(); ++ZRunner) {
-      elemental = periode->FindElement(*ZRunner);
-      ASSERT(elemental != NULL, "Invalid element specified in ElementCommandLineQuery");
-      elements.push_back(elemental);
+      temp = periode->FindElement(*ZRunner);
+      ASSERT(temp != NULL, "Invalid element specified in ElementCommandLineQuery");
+      tmp.push_back(temp);
     }
     return true;
   } else {
-    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing element for " << getTitle() << "." << endl);
-    return false;
-  }
-}
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing elements for " << getTitle() << "." << endl);
+    return false;
+  }
+}
Index: src/UIElements/CommandLineUI/CommandLineDialog.hpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -28,14 +28,20 @@
 
   virtual void queryEmpty(const char *, std::string = "");
-  virtual void queryInt(const char *, int *, std::string = "");
-  virtual void queryBoolean(const char *, bool *, std::string = "");
-  virtual void queryString(const char*, std::string *, std::string = "");
-  virtual void queryStrings(const char*, std::vector<std::string> *, std::string = "");
-  virtual void queryDouble(const char*, double*, std::string = "");
-  virtual void queryAtom(const char*,atom**, std::string = "");
-  virtual void queryMolecule(const char*,molecule**,std::string = "");
-  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
-  virtual void queryBox(const char*,double ** const, std::string = "");
-  virtual void queryElement(const char*, std::vector<element *> *, std::string = "");
+  virtual void queryInt(const char *, std::string = "");
+  virtual void queryInts(const char *, std::string = "");
+  virtual void queryBoolean(const char *, std::string = "");
+  virtual void queryString(const char*, std::string = "");
+  virtual void queryStrings(const char*, std::string = "");
+  virtual void queryDouble(const char*, std::string = "");
+  virtual void queryDoubles(const char*, std::string = "");
+  virtual void queryAtom(const char*, std::string = "");
+  virtual void queryAtoms(const char*, std::string = "");
+  virtual void queryMolecule(const char*, std::string = "");
+  virtual void queryMolecules(const char*, std::string = "");
+  virtual void queryVector(const char*, bool, std::string = "");
+  virtual void queryVectors(const char*, bool, std::string = "");
+  virtual void queryBox(const char*, std::string = "");
+  virtual void queryElement(const char*, std::string = "");
+  virtual void queryElements(const char*, std::string = "");
 
 protected:
@@ -50,6 +56,13 @@
   class IntCommandLineQuery : public Dialog::IntQuery {
   public:
-    IntCommandLineQuery(std::string title, int *_target, std::string _description = "");
+    IntCommandLineQuery(std::string title, std::string _description = "");
     virtual ~IntCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class IntsCommandLineQuery : public Dialog::IntsQuery {
+  public:
+    IntsCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~IntsCommandLineQuery();
     virtual bool handle();
   };
@@ -57,5 +70,5 @@
   class BooleanCommandLineQuery : public Dialog::BooleanQuery {
   public:
-    BooleanCommandLineQuery(std::string title, bool *_target, std::string _description = "");
+    BooleanCommandLineQuery(std::string title, std::string _description = "");
     virtual ~BooleanCommandLineQuery();
     virtual bool handle();
@@ -64,6 +77,13 @@
   class DoubleCommandLineQuery : public Dialog::DoubleQuery {
   public:
-    DoubleCommandLineQuery(std::string title, double *_target, std::string _description = "");
+    DoubleCommandLineQuery(std::string title, std::string _description = "");
     virtual ~DoubleCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class DoublesCommandLineQuery : public Dialog::DoublesQuery {
+  public:
+    DoublesCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~DoublesCommandLineQuery();
     virtual bool handle();
   };
@@ -71,5 +91,5 @@
   class StringCommandLineQuery : public Dialog::StringQuery {
   public:
-    StringCommandLineQuery(std::string title, std::string *_target, std::string _description = "");
+    StringCommandLineQuery(std::string title, std::string _description = "");
     virtual ~StringCommandLineQuery();
     virtual bool handle();
@@ -78,5 +98,5 @@
   class StringsCommandLineQuery : public Dialog::StringsQuery {
   public:
-    StringsCommandLineQuery(std::string title, std::vector<std::string> *_target, std::string _description = "");
+    StringsCommandLineQuery(std::string title, std::string _description = "");
     virtual ~StringsCommandLineQuery();
     virtual bool handle();
@@ -85,6 +105,13 @@
   class AtomCommandLineQuery : public Dialog::AtomQuery {
   public:
-    AtomCommandLineQuery(std::string title, atom **_target, std::string _description = "");
+    AtomCommandLineQuery(std::string title, std::string _description = "");
     virtual ~AtomCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class AtomsCommandLineQuery : public Dialog::AtomsQuery {
+  public:
+    AtomsCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~AtomsCommandLineQuery();
     virtual bool handle();
   };
@@ -92,6 +119,13 @@
   class MoleculeCommandLineQuery : public Dialog::MoleculeQuery {
   public:
-    MoleculeCommandLineQuery(std::string title, molecule **_target, std::string _description = "");
+    MoleculeCommandLineQuery(std::string title, std::string _description = "");
     virtual ~MoleculeCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class MoleculesCommandLineQuery : public Dialog::MoleculesQuery {
+  public:
+    MoleculesCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~MoleculesCommandLineQuery();
     virtual bool handle();
   };
@@ -99,6 +133,13 @@
   class VectorCommandLineQuery : public Dialog::VectorQuery {
   public:
-    VectorCommandLineQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = "");
+    VectorCommandLineQuery(std::string title,bool _check, std::string _description = "");
     virtual ~VectorCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class VectorsCommandLineQuery : public Dialog::VectorsQuery {
+  public:
+    VectorsCommandLineQuery(std::string title,bool _check, std::string _description = "");
+    virtual ~VectorsCommandLineQuery();
     virtual bool handle();
   };
@@ -106,5 +147,5 @@
   class BoxCommandLineQuery : public Dialog::BoxQuery {
   public:
-    BoxCommandLineQuery(std::string title,double ** const _cellSize, std::string _description = "");
+    BoxCommandLineQuery(std::string title, std::string _description = "");
     virtual ~BoxCommandLineQuery();
     virtual bool handle();
@@ -113,6 +154,13 @@
   class ElementCommandLineQuery : public Dialog::ElementQuery {
   public:
-    ElementCommandLineQuery(std::string title, std::vector<element *> *_target, std::string _description = "");
+    ElementCommandLineQuery(std::string title, std::string _description = "");
     virtual ~ElementCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class ElementsCommandLineQuery : public Dialog::ElementsQuery {
+  public:
+    ElementsCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~ElementsCommandLineQuery();
     virtual bool handle();
   };
Index: src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/CommandLineUI/CommandLineUIFactory.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineUIFactory.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/CommandLineUI/CommandLineUIFactory.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/CommandLineUI/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -44,5 +49,5 @@
   for (std::list<std::string>::iterator CommandRunner = CommandLineParser::getInstance().SequenceOfActions.begin(); CommandRunner != CommandLineParser::getInstance().SequenceOfActions.end(); ++CommandRunner) {
     cout << "Checking presence of " << *CommandRunner << ": ";
-    if (ActionRegistry::getInstance().isActionByNamePresent(*CommandRunner)) {
+    if (ActionRegistry::getInstance().isActionPresentByName(*CommandRunner)) {
       cout << "calling " << *CommandRunner << endl;
       ActionRegistry::getInstance().getActionByName(*CommandRunner)->call();
